unit Unit1;

interface

uses
  Windows, Messages, SysUtils,
  {$IFDEF VER140} Variants, {$ENDIF}
  {$IFDEF VER150} Variants, {$ENDIF}
  Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, rsStorage, ComCtrls, rsIniData;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    btnWalkForward: TButton;
    rsStorage1: TrsStorage;
    ListView1: TListView;
    btnWalkBackward: TButton;
    rsIniData1: TrsIniData;
    btnOpenIni: TButton;
    OpenDialog1: TOpenDialog;
    procedure btnWalkForwardClick(Sender: TObject);
    procedure btnWalkBackwardClick(Sender: TObject);
    procedure btnOpenIniClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure FillStorage;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.btnWalkForwardClick(Sender: TObject);
begin
  ListView1.Items.Clear;

  if rsStorage1.SectionFirst>=0 then
    repeat
      with ListView1.Items.Add do begin
        Caption := rsStorage1.SectionWrapper.Name;
        SubItems.Add(rsStorage1.SectionWrapper.FullName);
        SubItems.Add(IntToStr(rsStorage1.SectionWrapper.Level));
      end;
    until rsStorage1.SectionNext<0;
end;

procedure TForm1.FillStorage;
begin
  rsStorage1.ClearAll;
  rsStorage1.WriteBoolean('\S1-Level1\Key', False);
  rsStorage1.WriteBoolean('\S1-Level1\Level2\Key', False);
  rsStorage1.WriteBoolean('\S1-Level1\Level2\Key1', False);
  rsStorage1.WriteBoolean('\S1-Level1\Level2\Level3\Key1', False);
  rsStorage1.WriteBoolean('\S2-Level1\key', False);
  rsStorage1.WriteBoolean('\S3-Level1\key', False);
  rsStorage1.WriteBoolean('\S3-Level1\Level2\Level3\Level4\key', False);
end;

procedure TForm1.btnWalkBackwardClick(Sender: TObject);
begin
  ListView1.Items.Clear;

  if rsStorage1.SectionLast>=0 then
    repeat
      with ListView1.Items.Add do begin
        Caption := rsStorage1.SectionWrapper.Name;
        SubItems.Add(rsStorage1.SectionWrapper.FullName);
        SubItems.Add(IntToStr(rsStorage1.SectionWrapper.Level));
      end;
    until rsStorage1.SectionPrior<0;
end;

procedure TForm1.btnOpenIniClick(Sender: TObject);
begin
  OpenDialog1.InitialDir := ExtractFileDir(Application.ExeName);
  if OpenDialog1.Execute then begin
    rsIniData1.FileName := OpenDialog1.FileName;
    rsStorage1.Load;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FillStorage;
end;

end.
